package com.fjhx.file.enums;

import org.apache.commons.collections4.MapUtils;

import java.util.LinkedHashMap;
import java.util.Map;

public enum FileTypeEnums {
    FILE_TYPE_0(0, "待定"),
    FILE_TYPE_1(0, "待定"),
    FILE_TYPE_2(0, "待定"),
    FILE_TYPE_10(10, "到货检验-样品采集记录文件"),
    FILE_TYPE_20(20, "到货检验-工序照片文件"),
    FILE_TYPE_30(30, "到货检验-物品缺陷照片文件"),
    FILE_TYPE_40(40, "到货检验-支持文档视频文件"),
    FILE_TYPE_50(50, "待定"),
    FILE_TYPE_60(60, "待定"),
    FILE_TYPE_70(70, "待定"),
    FILE_TYPE_80(80, "待定"),
    FILE_TYPE_90(90, "待定"),
    FILE_TYPE_99(99, "其他"),
    ;
    private Integer key;

    private String value;

    private static Map<Integer, String> map = new LinkedHashMap<>();

    FileTypeEnums(Integer key, String value) {
        this.key = key;
        this.value = value;
    }

    /**
     * 获取枚举map
     *
     * @return
     */
    public static Map<Integer, String> getMap() {
        if (MapUtils.isNotEmpty(map)) {
            return map;
        }
        for (FileTypeEnums ms : values()) {
            map.put(ms.key, ms.value);
        }
        return map;
    }

    public Integer getKey() {
        return key;
    }

    public String getValue() {
        return value;
    }
}
