package com.fjhx.flow.controller.flow;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.flow.entity.flow.dto.FlowDefinitionDto;
import com.fjhx.flow.entity.flow.dto.FlowDefinitionSelectDto;
import com.fjhx.flow.entity.flow.po.FlowDefinition;
import com.fjhx.flow.entity.flow.vo.FlowDefinitionPageVo;
import com.fjhx.flow.entity.flow.vo.FlowDefinitionVo;
import com.fjhx.flow.service.flow.FlowDefinitionService;
import com.ruoyi.common.annotation.TenantIgnore;
import com.ruoyi.common.constant.BaseSourceConstant;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;


/**
 * <p>
 * 流程定义 前端控制器
 * </p>
 *
 * @author
 * @since 2023-03-15
 */
@TenantIgnore
@DS(BaseSourceConstant.BASE)
@RestController
@RequestMapping("/flowDefinition")
public class FlowDefinitionController {

    @Autowired
    private FlowDefinitionService flowDefinitionService;

    /**
     * 租户流程分页
     */
    @PostMapping("/page")
    public Page<FlowDefinitionPageVo> page(@RequestBody FlowDefinitionSelectDto dto) {
        return flowDefinitionService.getPage(dto);
    }

    /**
     * 添加租户流程
     */
    @PostMapping("/add")
    public void add(@Validated @RequestBody FlowDefinition flowDefinition) {
        flowDefinitionService.add(flowDefinition);
    }

    /**
     * 添加租户流程版本
     */
    @PostMapping("/addVersion")
    public void addVersion(@Validated @RequestBody FlowDefinitionDto dto) {
        flowDefinitionService.addVersion(dto);
    }

    /**
     * 修改流程版本
     */
    @PostMapping("/updateVersion")
    public void updateVersion(@RequestBody FlowDefinition flowDefinition) {
        flowDefinitionService.updateVersion(flowDefinition.getId());
    }

    /**
     * 获取流程版本
     */
    @PostMapping("/getVersionList")
    public List<FlowDefinition> getVersionList(@RequestBody FlowDefinition flowDefinition) {
        return flowDefinitionService.getVersionList(flowDefinition);
    }

    /**
     * 查看详情
     */
    @PostMapping("/getDetails")
    public FlowDefinitionVo getDetails(@RequestBody BaseSelectDto dto) {
        return flowDefinitionService.getDetails(dto);
    }

}
