package com.fjhx.flow.entity.flow.dto;

import com.alibaba.fastjson.JSONObject;
import com.fjhx.file.entity.ObsFile;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotNull;
import java.util.List;

@Getter
@Setter
public class JumpDto {

    /**
     * 流程id
     */
    @NotNull(message = "流程id不能为空")
    private Long flowId;

    /**
     * 处理类型:
     * 1跳转下一节点
     * 2返回上一节点
     * 3结束流程
     * 4退回到发起人
     */
    @NotNull(message = "跳转节点不能为空")
    private Integer handleType;

    /**
     * 流程实例版本
     */
    @NotNull(message = "流程实例版本不能为空")
    private Integer version;

    /**
     * 下级节点审批人
     */
    private Long handleUserId;

    /**
     * 处理备注
     */
    private String remark;

    /**
     * 提交数据
     */
    private JSONObject data;

    /**
     * 节点附件
     */
    private List<ObsFile> fileList;

}
