package com.fjhx.flow.entity.flow.po;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotBlank;

/**
 * <p>
 * 流程信息
 * </p>
 *
 * @author
 * @since 2023-03-15
 */
@Getter
@Setter
@TableName("flow_info")
public class FlowInfo extends BasePo {

    /**
     * 分类名称
     */
    @NotBlank(message = "分类名称不能为空")
    private String classifyName;

    /**
     * 流程名称
     */
    @NotBlank(message = "流程名称不能为空")
    private String flowName;

    /**
     * 流程标识
     */
    @NotBlank(message = "流程标识不能为空")
    private String flowKey;

    /**
     * 流程状态
     * 1启用
     * 0禁用
     */
    private Integer status;

    /**
     * 业务ID
     */
    @TableField(exist = false)
    private Long businessId;


}
