package com.fjhx.flow.entity.flow.vo;

import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;

@Getter
@Setter
public class ApprovalRecordVo {

    /**
     * 流程实例id
     */
    private Long id;

    /**
     * 实例版本
     */
    private Integer version;

    /**
     * 处理当前节点按钮列表
     */
    private List<ButtonInfo> buttonInfoList;

    /**
     * 审批记录
     */
    private List<Record> recordList;

    /**
     * 当前流程状态
     */
    private Integer status;

    @Getter
    @Setter
    public static class ButtonInfo {

        /**
         * 按钮处理类型
         */
        private Integer type;

        /**
         * 按钮名称
         */
        private String name;

    }

    @Getter
    @Setter
    public static class Record {

        /**
         * 状态 1已处理 2进行中 3未开始
         */
        private Integer status;

        /**
         * 节点id
         */
        private Long nodeId;

        /**
         * 节点类型 1开始 2办理 3分支 99结束
         */
        private Integer nodeType;

        /**
         * 节点名称
         */
        private String nodeName;

        /**
         * 处理时间
         */
        private Date processedDate;

        /**
         * 处理人
         */
        private String processedUser;

        /**
         * 处理人id
         */
        private Long processedUserId;

        /**
         * 处理意见
         */
        private String remark;

        /**
         * 处理记录id
         */
        private Long flowExampleDetailId;

        /**
         * 处理类型 1、跳转下一节点 2、结束流程 3、返回上一节点 4、退回到发起人
         */
        private Integer handleType;

        /**
         * 处理类型名称
         */
        private String handleTypeName;

    }

}
