package com.fjhx.flow.enums;

import com.ruoyi.common.exception.ServiceException;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.HashMap;
import java.util.Map;

@Getter
@AllArgsConstructor
public enum HandleTypeEnum {

    SKIP_TO_NEXT(1, "通过"),
    REJECT(2, "驳回"),
    RETURN_TO_PREVIOUS(3, "返回上一步"),
    RETURN_TO_SUBMITTER(4, "退回到发起人"),
    ;

    private final Integer key;

    private final String value;

    private static final Map<Integer, HandleTypeEnum> map = new HashMap<>();

    static {
        for (HandleTypeEnum value : HandleTypeEnum.values()) {
            map.put(value.getKey(), value);
        }
    }

    public static HandleTypeEnum getEnum(Integer key) {
        HandleTypeEnum handleTypeEnum = map.get(key);
        if (handleTypeEnum == null) {
            throw new ServiceException("未知流程跳转类型");
        }
        return handleTypeEnum;
    }

}
