package com.fjhx.socket.controller.push;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.socket.entity.push.dto.PushAnnouncementDto;
import com.fjhx.socket.entity.push.dto.PushAnnouncementSelectDto;
import com.fjhx.socket.entity.push.vo.PushAnnouncementVo;
import com.fjhx.socket.service.push.PushAnnouncementService;
import com.ruoyi.common.constant.BaseSourceConstant;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * <p>
 * 公告 前端控制器
 * </p>
 *
 * @author
 * @since 2023-07-13
 */
@DS(BaseSourceConstant.BASE)
@RestController
@RequestMapping("/pushAnnouncement")
public class PushAnnouncementController {

    @Autowired
    private PushAnnouncementService pushAnnouncementService;

    /**
     * 公告分页
     */
    @PostMapping("/page")
    public Page<PushAnnouncementVo> page(@RequestBody PushAnnouncementSelectDto dto) {
        return pushAnnouncementService.getPage(dto);
    }

    /**
     * 公告明细
     */
    @PostMapping("/detail")
    public PushAnnouncementVo detail(@RequestBody BaseSelectDto dto) {
        return pushAnnouncementService.detail(dto.getId());
    }

    /**
     * 公告新增
     */
    @PostMapping("/add")
    public void add(@RequestBody PushAnnouncementDto pushAnnouncementDto) {
        pushAnnouncementService.add(pushAnnouncementDto);
    }

    /**
     * 公告编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody PushAnnouncementDto pushAnnouncementDto) {
        pushAnnouncementService.edit(pushAnnouncementDto);
    }

    /**
     * 公告删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        pushAnnouncementService.delete(dto.getId());
    }

}
