package com.fjhx.socket.controller.push;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.socket.entity.push.dto.PushInfoSelectDto;
import com.fjhx.socket.entity.push.vo.PushInfoVo;
import com.fjhx.socket.service.push.PushInfoService;
import com.ruoyi.common.constant.BaseSourceConstant;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * <p>
 * 消息推送 前端控制器
 * </p>
 *
 * @author
 * @since 2023-07-13
 */
@DS(BaseSourceConstant.BASE)
@RestController
@RequestMapping("/pushInfo")
public class PushInfoController {

    @Autowired
    private PushInfoService pushInfoService;

    /**
     * 消息推送分页
     */
    @PostMapping("/page")
    public Page<PushInfoVo> page(@RequestBody PushInfoSelectDto dto) {
        return pushInfoService.getPage(dto);
    }

    /**
     * 消息推送明细
     */
    @PostMapping("/detail")
    public PushInfoVo detail(@RequestBody BaseSelectDto dto) {
        return pushInfoService.detail(dto.getId());
    }

    @PostMapping("/read")
    public void read(@RequestBody PushInfoSelectDto dto) {
        pushInfoService.read(dto.getIdList());
    }

}
