package com.fjhx.socket.core.event;

import com.fjhx.socket.core.PushParam;
import com.fjhx.socket.core.PushTypeEnum;
import lombok.Getter;
import org.springframework.context.ApplicationEvent;

/**
 * webStock推送的用户离线事件
 */
@Getter
public class WebSocketUserOfflineEvent extends ApplicationEvent {

    private final PushTypeEnum pushTypeEnum;
    private final PushParam pushParam;

    public WebSocketUserOfflineEvent(PushTypeEnum pushTypeEnum, PushParam pushParam) {
        super(WebSocketUserOfflineEvent.class);
        this.pushTypeEnum = pushTypeEnum;
        this.pushParam = pushParam;
    }

}