package com.ruoyi.framework.aspect;

import com.ruoyi.common.annotation.LogicIgnore;
import com.ruoyi.framework.mybatis.holder.LogicHolder;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.springframework.stereotype.Component;

/**
 * 逻辑删除切面
 */
@Aspect
@Component
public class LogicAspect {

    /**
     * 去除逻辑删除
     * @param point
     * @param logicIgnore
     * @return
     * @throws Throwable
     */
    @Around("@annotation(logicIgnore) || @within(logicIgnore)")
    public Object around(ProceedingJoinPoint point, LogicIgnore logicIgnore) throws Throwable {
        try {
            // 开启忽略
            LogicHolder.setLogicHolder(true);
            // 执行方法
            return point.proceed();
        } finally {
            // 关闭忽略
            LogicHolder.clear();
        }
    }

}
