package com.ruoyi.system.utils;

import cn.hutool.extra.spring.SpringUtil;
import com.baomidou.dynamic.datasource.toolkit.DynamicDataSourceContextHolder;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.common.constant.BaseSourceConstant;
import com.ruoyi.common.core.domain.BaseEntity;
import com.ruoyi.system.domain.SysConfig;
import com.ruoyi.system.service.ISysConfigService;

import java.util.Date;

/**
 * 配置util
 */
public class ConfigUtil {

    private static final ISysConfigService configService = SpringUtil.getBean(ISysConfigService.class);

    public static String get(String key) {
        DynamicDataSourceContextHolder.push(BaseSourceConstant.BASE);
        SysConfig sysConfig = configService.getOne(Wrappers.<SysConfig>lambdaQuery().eq(SysConfig::getConfigKey, key));
        DynamicDataSourceContextHolder.poll();

        if (sysConfig == null) {
            return "";
        }

        return sysConfig.getConfigValue();
    }

    public static void set(String key, String value) {
        DynamicDataSourceContextHolder.push(BaseSourceConstant.BASE);
        boolean flag = configService.update(Wrappers.<SysConfig>lambdaUpdate()
                .eq(SysConfig::getConfigKey, key)
                .set(SysConfig::getConfigValue, value)
                .set(BaseEntity::getUpdateTime, new Date())
        );

        if (!flag) {
            Date date = new Date();
            SysConfig config = new SysConfig();
            config.setConfigKey(key);
            config.setConfigValue(value);
            config.setConfigType("Y");
            config.setCreateTime(date);
            config.setUpdateTime(date);
            configService.save(config);
        }

        DynamicDataSourceContextHolder.poll();
    }

}
